
var OIB_DownloadOverlay = {
  dialogAcceptRetVal: true,

  _getMime: function OIBDO_getMime() {
    var itemId = document.getElementById("mimeTypesMenu").selectedItem.id;
    var mime = itemId.replace(/^mimeid_/, "");
    if (mime != "other")
      return mime;

    mime = document.getElementById("mimeOtherText").value;
    if (!OpenInBrowser.validateMime(mime))
      mime = null;

    return mime;
  },

  dialogAccepted: function OIBDO_dialogAccepted() {
    if (document.getElementById('mode').selectedItem.id != "openInBrowser")
      return false;

    var parent = dialog.mContext.QueryInterface(Ci.nsIInterfaceRequestor)
                                .getInterface(Ci.nsIDOMWindowInternal);

    this.dialogAcceptRetVal = true;

    var mime = this._getMime();
    if (!mime) {
      // if the mime type is not valid, keep the dialog open
      this.dialogAcceptRetVal = false;
    } else {
      OpenInBrowser.reloadWithMime(dialog.mLauncher.source, mime);
    }

    return true;
  },

  init: function OIBDO_init(event) {

    // The Unknown Content Type dialog can have two different layouts.
    // Under some conditions (executables, ...), the dialog only shows
    // the save button. In that case the layout is modified in order to
    // show the radio button for selecting the mime type.
    if (dialog.dialogElement("normalBox").collapsed) {
      document.getElementById("normalBox").collapsed = false;
      document.getElementById("mode").firstChild.collapsed = true;

      // restore button labels
      document.documentElement.mStrBundle.GetStringFromName("button-accept");
      var docEl = document.documentElement;
      docEl.getButton("accept").label = docEl.mStrBundle.GetStringFromName("button-accept");
      docEl.getButton("cancel").label = docEl.mStrBundle.GetStringFromName("button-cancel");

      document.getElementById("rememberChoice").collapsed = true;
    }

    document.documentElement.setAttribute('ondialogaccept',
      'if(OIB_DownloadOverlay.dialogAccepted()) {' +
      '  return OIB_DownloadOverlay.dialogAcceptRetVal;' +
      '} else {' +
        document.documentElement.getAttribute('ondialogaccept') +
      '}');

    // disable the remember choice label, as choice remembering
    //  is not implemented yet for open in browser.
    if (!document.getElementById("rememberChoice").disabled) {
      function modeCmd(event) {
        if (event.target.localName != "radio")
          return;

        var oibRadio = document.getElementById("openInBrowser");
        var rememberChoice = document.getElementById("rememberChoice");
        rememberChoice.disabled = (event.target == oibRadio);
      }
      document.getElementById("mode").addEventListener('command', modeCmd, false);
    }

    var mimeTypesPopup = document.getElementById("mimeTypesPopup");

    OpenInBrowser.populateMenu(mimeTypesPopup, dialog.mLauncher.source);

    // arbitrary image mime type. See comment on top of openInBrowser.js file.
    var MIME_IMAGE = "image/jpeg";

    // Pre-select correct mime type if available
    var mimeType = dialog.mLauncher.MIMEInfo.MIMEType;
    if (/^image\//.test(mimeType))
        mimeType = MIME_IMAGE;

    var mimeItem = document.getElementById("mimeid_" + mimeType) ||
                   mimeTypesPopup.firstChild;
    document.getElementById('mimeTypesMenu').selectedItem = mimeItem;
  },

  onMimeTypeChange: function(event) {
    var isOther = event.target.id == "mimeid_other";
    var otherText = document.getElementById("mimeOtherText");

    document.getElementById("mimeOtherText");
    otherText.hidden = !isOther;
    document.getElementById("mode").selectedItem =
             document.getElementById("openInBrowser");
    if (isOther) {
      otherText.focus();
    }
    window.sizeToContent();
  }
}

window.addEventListener('load', function init() {
  OIB_DownloadOverlay.init();
}, false);
